unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Ed_Name: TEdit;
    Ed_Strana: TEdit;
    Ed_KolVo: TEdit;
    Ed_Cena: TEdit;
    Ed_Trebuet: TEdit;
    Ed_FIO: TEdit;
    Ed_Data: TEdit;
    L_Name: TLabel;
    L_Strana: TLabel;
    L_KolVo: TLabel;
    L_Cena: TLabel;
    L_Pokupatel: TLabel;
    L_Trebuet: TLabel;
    L_FIO: TLabel;
    L_Data: TLabel;
    Add: TButton;
    RG: TRadioGroup;
    Delete: TButton;
    Ed_Pokupatel: TEdit;
    LeftClick: TBitBtn;
    RightClick: TBitBtn;
    AllLeftClick: TBitBtn;
    AllRightClick: TBitBtn;
    OD: TOpenDialog;
    SD: TSaveDialog;
    Open: TButton;
    Save: TButton;
    Otbor1: TButton;
    Ed_Otbor2: TEdit;
    Otbor2: TButton;
    Ed_Otbor3: TEdit;
    Otbor3: TButton;
    Close: TBitBtn;
    ClearAll: TButton;
    procedure RGClick(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure RightClickClick(Sender: TObject);
    procedure LeftClickClick(Sender: TObject);
    procedure AllRightClickClick(Sender: TObject);
    procedure AllLeftClickClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure Otbor1Click(Sender: TObject);
    procedure Otbor2Click(Sender: TObject);
    procedure Otbor3Click(Sender: TObject);
    procedure ClearAllClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

p_sklad=^all_sklad;
all_sklad= record
name, strana : string[30];
cena:integer;
next, prior:p_sklad;

case item : Char of
  'y':(kolvo,trebuet:integer;
       pokupatel:string[30]);
  'n': ( fio,data:string[50]);
end;

var
  Form1: TForm1;
  head, sklad, vsklad:p_sklad;

  implementation

{$R *.dfm}

 procedure viewsklad(skladview: p_sklad);
begin
  with skladview^,form1 do
  begin
    Ed_Name.text:=skladview^.name;
    Ed_Strana.text:=strana;
    Ed_Cena.text:=inttostr(cena);
    case item of
      'y':
        begin
          Ed_KolVo.text:=inttostr(kolvo);
          Ed_Pokupatel.text:=pokupatel;
          Ed_Trebuet.text:=inttostr(trebuet);
          RG.ItemIndex:=0;
        end;
      'n':
        begin
          Ed_FIO.text:=fio;
          Ed_Data.text:=data;
          RG.ItemIndex:=1;
        end;
     end;
  end;
end;

procedure TForm1.RGClick(Sender: TObject);
begin
  case RG.itemindex  of
    0:
      begin
        L_KolVo.Visible:=true;
        L_Pokupatel.Visible:=true;
        L_trebuet.Visible:=true;
        L_FIO.Visible:=false;
        L_Data.Visible:=false;
        Ed_KolVo.Visible:=true;
        Ed_Pokupatel.Visible:=true;
        Ed_trebuet.Visible:=true;
        Ed_Fio.Visible:=false;
        Ed_Data.Visible:=false;
      end;
    1:
      begin
        l_KolVo.Visible:=false;
        l_FIO.Visible:=true;
        l_Data.Visible:=true;
        l_Pokupatel.Visible:=false;
        l_Trebuet.Visible:=false;
        ed_KolVo.Visible:=false;
        ed_Fio.Visible:=true;
        ed_Data.Visible:=true;
        ed_pokupatel.Visible:=false;
        ed_trebuet.Visible:=false;
      end;
   end;
end;

 procedure TForm1.AddClick(Sender: TObject);
var
  sklad_pred: p_sklad;
  i:integer;
begin
  if ((RG.ItemIndex=0) and
     (Ed_Name.Text<>'') and
     (Ed_Strana.Text<>'') and
     (Ed_Cena.Text<>'') and
     (Ed_KolVo.Text<>'') and
     (Ed_Pokupatel.Text<>'') and
     (Ed_Trebuet.Text<>''))
    or
     ((RG.ItemIndex=1) and
     (Ed_Name.Text<>'') and
     (Ed_Strana.Text<>'') and
     (Ed_Cena.Text<>'') and
     (Ed_FIO.Text<>'') and
     (Ed_Data.Text<>''))
  then
    begin
      sklad_pred:=sklad;
      new(sklad);
        with sklad^ do
        begin
          prior:=nil;
          next:=nil;
          name:=ed_Name.text;
          strana:=ed_Strana.text;
          cena:=strtoint(ed_Cena.text);
          case rG.itemindex  of
            0:
              begin
                kolvo:=strtoint(ed_KolVo.text);
                pokupatel:=ed_Pokupatel.text;
                trebuet:=strtoint(ed_Trebuet.text);
                item:='y'
              end;
            1:
              begin
                fio:=ed_FIO.text;
                data:=ed_Data.text;
                item:='n'
              end;
          end;
          if head<>nil then
          begin
            sklad^.prior:=sklad_pred;
            sklad_pred^.next:=sklad
          end
          else
            head:=sklad;
            for i:=0 to form1.ComponentCount-1 do
            if form1.Components[i] is TEdit then
              (form1.Components[i] as TEdit).Text:='';
        end;
     end
  else showmessage('   !');
end;

procedure TForm1.SaveClick(Sender: TObject);
var
  File0: File of all_sklad;
  ib: p_sklad;
begin
  if SD.Execute then
  begin
    AssignFile(File0, SD.Filename);
    Rewrite(File0);
    ib:=head;
    while ib<>nil do
    begin
      write(File0,ib^);
      ib:=ib^.next;
    end;
    closefile(File0);
  end;
end;

procedure TForm1.LeftClickClick(Sender: TObject);
begin
  if sklad=nil then
    showmessage (' ')
  Else
  begin
    if sklad^.prior=nil then
      showmessage('  ')
    else
    begin
      sklad:=sklad^.prior;
      viewsklad(sklad)
    end;
  end;
end;

procedure TForm1.RightClickClick(Sender: TObject);
begin
  if sklad=nil then
    showmessage (' ')
  else
  begin
    if (sklad^.next=nil)or (head=nil) then
      showmessage('  ')
    else
    begin
      sklad:=sklad^.next;
      viewsklad(sklad)
    end;
  end;
end;

procedure TForm1.AllLeftClickClick(Sender: TObject);
begin
  if sklad=nil then
    showmessage (' ')
  else
  begin
    if (sklad^.prior=nil) then
      showmessage ('  !')
    else
    begin
      sklad:=head;
      viewsklad(sklad);
    end;
  end;
end;

 procedure TForm1.AllRightClickClick(Sender: TObject);
begin
  if sklad=nil then
    showmessage (' ')
  else
  begin
    if (sklad^.next=nil) or (head=nil) then
      showmessage('  ')
    else
    begin
      while sklad^.next <> nil do
        sklad:=sklad^.next
    end;
    viewsklad(sklad);
  end;
end;

 procedure TForm1.OpenClick(Sender: TObject);
var
  File0: file of all_sklad;
  sklad_pred: p_sklad;
begin
  if OD.Execute then
    begin
      AssignFile(File0, OD.Filename);
      Reset(File0);
      while not eof(File0) do
      begin
        sklad_pred:=sklad;
        new(sklad);
        read(File0, sklad^);
        sklad^.next:=nil;
        sklad^.prior:=sklad_pred;
        if head=nil then
          head:=sklad
        else
        begin
          sklad_pred^.next:=sklad;
        end;
      end;
      vsklad:=sklad;
      closefile(File0);
      viewsklad(vsklad);
    end;
end;

procedure TForm1.DeleteClick(Sender: TObject);
var
  sklad_pred:p_sklad;
  i:integer;
begin
  If sklad=nil then
    showmessage (' ')
   else
     if (sklad^.next=nil) and (sklad^.prior=nil) then
       showmessage ('  ')
     else
       if sklad^.prior=nil then
       begin
         sklad^.next^.prior:=nil;
         head:=sklad^.next;
         dispose(sklad);
         sklad:=head
       end
       else
         if sklad^.next=nil then
         begin
           sklad^.prior^.next:=nil;
           sklad_pred:=sklad^.prior;
           dispose(sklad);
           sklad:=sklad_pred;
         end
         else
         begin
           sklad^.prior^.next:=sklad^.next;
           sklad_pred:=sklad;
           sklad:=sklad^.next;
           dispose(sklad^.prior);
           sklad^.prior:=sklad_pred^.prior;
         end;
         if head=nil then
         begin
           for i:=0 to form1.ComponentCount-1 do
           if form1.Components[i] is TEdit then
             (form1.Components[i] as TEdit).Text:='';
         end
         else
           viewsklad(sklad);
end;

 procedure TForm1.ClearAllClick(Sender: TObject);
var
  item: p_sklad;
begin
  if Sklad = nil then
    Exit
  else
    item := sklad;
  while item^.next <> nil do
  begin
    if item^.prior <> nil then
      Dispose(item^.prior);
    if item^.next <> nil then
      item := item^.next;
  end;
  Dispose(item);
  Sklad := nil;
  RG.ItemIndex:=0;
  Ed_Name.Text:='';
  Ed_Strana.Text:='';
  Ed_Cena.Text:='';
  Ed_KolVo.Text:='';
  Ed_Pokupatel.Text:='';
  Ed_Trebuet.Text:='';
  Ed_FIO.Text:='';
  Ed_Data.Text:='';
end;

procedure TForm1.Otbor1Click(Sender: TObject);
var
  File0: file of all_sklad;
  sklad_pred: p_sklad;
begin
  if OD.Execute then
  begin
    AssignFile(File0, OD.Filename);
    Reset(File0);
    while not eof(File0) do
    begin
      if sklad^.item = 'y'then
      begin
        sklad_pred:=sklad;
        new(sklad);

        read(File0, sklad^);
        sklad^.next:=nil;
        sklad^.prior:=sklad_pred;
      if head=nil then
        head:=sklad
      else
      begin
        sklad_pred^.next:=sklad;
      end;
      end;
      vsklad:=sklad;
      closefile(File0);
      viewsklad(vsklad);
    end;
  end;
end;

procedure TForm1.Otbor2Click(Sender: TObject);
var
  File0: file of all_sklad;
  sklad_pred: p_sklad;
begin
  if OD.Execute then
  begin
    AssignFile(File0, OD.Filename);
    Reset(File0);
    while not eof(File0) do
    begin
      if (ed_Otbor2.Text=sklad^.pokupatel) or (ed_otbor2.Text=sklad^.fio) then
      begin
        sklad_pred:=sklad;
        new(sklad);
        read(File0, sklad^);
        sklad^.next:=nil;
        sklad^.prior:=sklad_pred;
        if head=nil then
          head:=sklad
        else
        begin
          sklad_pred^.next:=sklad;
        end;
      end;
      vsklad:=sklad;
      closefile(File0);
      viewsklad(vsklad);
    end;
  end;
end;

procedure TForm1.Otbor3Click(Sender: TObject);
var
  File0: file of all_sklad;
  sklad_pred: p_sklad;
begin
  if OD.Execute then
  begin
    AssignFile(File0, OD.Filename);
    Reset(File0);
    while not eof(File0) do
    begin
      if (ed_Otbor3.Text=sklad^.name) then
        begin
          sklad_pred:=sklad;
          new(sklad);
          read(File0, sklad^);
          sklad^.next:=nil;
          sklad^.prior:=sklad_pred;
          if head=nil then
            head:=sklad
          else
          begin
            sklad_pred^.next:=sklad;
          end;
        end;
        vsklad:=sklad;
        closefile(File0);
        viewsklad(vsklad);
    end;
  end;
end;
end.

